var y y_f C CH CF CH_f C_f I q  lambda_c K  mc r  r_k rf bf b_h t tf z_y  pi pih pif pif_f ph pf pf_f P w tau_c tau_h tau_P
N  G Gf  cobs piobs wobs  yobs y_fobs pif_fobs robs;
varexo  xi_y xi_C_f   xi_rf xi_b xi_pf_f  xi_tau_c xi_tau_h xi_tau_P  xi_g  xi_gf;
//----------------------------------------------------//
// Declaration of parameters //
//----------------------------------------------------//
parameters alpha alpha_N beta delta  vepsilon  eta  h   g_y gyf c_y  omega_pi omega_y omega_r phi
sigma vphi   rho_rf  lambda tetha mu_tau_c mu_tau_h mu_tau_P    ksi
rho_y  rho_C_f  rho_pf_f rho_g rho_gf  phSS pfSS pf_fSS  r_k_ss  mu_g phi_g phi_b
bhSS bfSS pi_fSS rSS  tau_c_ss rho_tau_c rho_tau_P tau_h_ss tau_PSS rho_tau_h ;
alpha = 0.26;
alpha_N=0.33;
beta = 0.99;
delta=0.025;
tetha=0.75;
vepsilon=5.855;
ksi=1;
phi_g=0.2;
phi_b=0.2;
sigma=1.0;
lambda=(1-tetha)*(1-beta*tetha)/tetha;
r_k_ss=(1/beta)-(1-delta);
vphi =1.577;
eta = 1.1;
tau_c_ss=0.2;
tau_h_ss=0.13;
tau_PSS=0.18;
mu_tau_c=0.1;
mu_tau_h=0.1;
mu_tau_P=0.1;
omega_pi = 1.5;
omega_y = 0.7;
omega_r = 0.8;
phi = 0.02;
h = 0.75;
rho_y = 0.5;
rho_g = 0.55;
rho_gf = 0.65;
rho_rf = 0.65;
rho_pf_f = 0.65;
rho_C_f = 0.65;
rho_tau_c = 0.65;
rho_tau_h = 0.65;
rho_tau_P = 0.65;
mu_g=0.2;
g_y=0.15;
gyf=0.4;
c_y=0.7;
//SS values Dynare v.4
phSS = 1;
pfSS = 1.0;
pf_fSS=1.0;
pi_fSS = 1;
rSS = (1/beta);
//CSS=c_y*ySS;

bhSS=0;
bfSS=0;
//----------------------------------------------------//
// DSGE model specification //
//----------------------------------------------------//
model(linear);
#mcSS=(vepsilon-1)/vepsilon;
#wSS=(mcSS/((r_k_ss^alpha_N)*(1/(1-alpha_N))^(1-alpha_N)*(1/alpha_N)^alpha_N))^(1/(1-alpha_N));
#NSS=(((((1-g_y)*(beta^(-1)-1)-g_y*delta)*(1-h))^(-1))*((1/beta)-1+delta)*(1-alpha)/alpha)^(1/(1+vphi));
#KSS=((((1-g_y)*(beta^(-1)-1)-g_y*delta)*(1-h))^(-1/(1+vphi)))*(alpha_N*mcSS)^((1+vphi)/((1-alpha_N)*(1+vphi)))*((1/beta)-1+delta)^((alpha_N+vphi)/((alpha_N-1)*(1+vphi)))*((1-alpha_N)/alpha_N)^(1/(1+vphi));
#ySS=(KSS^alpha_N)*NSS^(1-alpha_N);
#CSS=((1-g_y)*mcSS*(KSS/NSS)^alpha_N-delta*(KSS/NSS))*NSS;
#ISS=delta*KSS;
#CH_fSS = 0.025*CSS;
#GSS=g_y*ySS;
#GfSS=gyf*ySS;
#CHSS=(1-alpha)*CSS;
#CFSS=alpha*CSS;
#gammac=(alpha^(1/eta)*CFSS^((eta-1)/eta))/((1-alpha)^(1/eta)*CHSS^((eta-1)/eta)+alpha^(1/eta)*CFSS^((eta-1)/eta));
#PSS=(phSS-mcSS)*(CHSS+CH_fSS)+(pfSS-pf_fSS)*CFSS;
#tSS=tau_h_ss*wSS*NSS+tau_PSS*PSS;
#tfSS=tau_c_ss*CSS;
//Demand
C = (1-gammac)*CH+gammac*CF;
CH = C-eta*(ph);
CF = C-eta*(pf);
CH_f = C_f-eta*(ph-pf_f);
//y = (CHSS/ySS)*CH+(CH_fSS/ySS)*CH_f+(GSS/ySS)*G+(IHSS/ySS)*IH+(IH_fSS/ySS)*IH_f;
y = (CHSS/ySS)*CH+(CH_fSS/ySS)*CH_f+(GSS/ySS)*G+(ISS/ySS)*I;
y = z_y+alpha_N*K(-1)+(1-alpha_N)*N;
//Euler
r = (sigma/(1-h))*C(+1)-((1+h)/(1-h))*sigma*C+(h*sigma/(1-h))*C(-1)+pi(+1)-(tau_c_ss/(1+tau_c_ss))*(tau_c-tau_c(+1));
q=(lambda_c(+1)-lambda_c)+beta*(r_k_ss*r_k(+1)*(1-tau_h_ss)-r_k_ss*tau_h_ss*tau_h(+1))+beta*q(+1);
q=ksi*(I-K(-1));
K=(1-delta)*K(-1)+delta*I;
lambda_c=-((tau_c_ss*tau_c)/(1+tau_c_ss))-(C-h*C(-1))/(1-h);
//Intratemporal
w = vphi*N+(sigma/(1-h))*C-((sigma*h)/(1-h))*C(-1)+(tau_c_ss/(1+tau_c_ss))*tau_c+(tau_h_ss/(1-tau_h_ss))*tau_h;
//Producer FOC
mc=alpha_N*r_k+(1-alpha_N)*(w)-z_y;
pih=beta*pih(+1)+lambda*mc;
pif=beta*pif(+1)+lambda*(pf_f-pf);
//UIP
r -rf= -phi*bf+xi_b;
//Taylor
rf = omega_r*rf(-1)+((1-omega_r)/rSS)*(omega_pi*pif_f+omega_y*ySS*(y_f-y_f(-1)))+xi_rf;
//Bonds
//b*bf-bf(-1)/pi_fSS = phSS*CH_fSS*(ph+CH_f)-CFSS*CF;
//Pi
//pi = (1-alpha)*phSS^(1-eta)*pih+alpha*pfSS^(1-eta)*pif;
pif = pf-pf(-1)+pi;
pih = ph-ph(-1)+pi;
pif_f=pf_f-pf_f(-1)+pi;
GSS*G+bhSS*b_h(-1)=tau_h_ss*wSS*NSS*(tau_h+w+N)+tau_h_ss*r_k_ss*KSS*(tau_h+r_k+K)+(bhSS/rSS)*(b_h-r)+tau_PSS*PSS*(tau_P+P);
GfSS*Gf+bfSS*bf(-1)=tau_c_ss*CSS*(tau_c+C)+(bfSS/rSS)*(bf-rf);
P*PSS=phSS*(CHSS+CH_fSS)*ph-(w*wSS*NSS/(alpha_N*ySS))*(CHSS+CH_fSS)+(wSS*NSS*N/(alpha_N*ySS))*(CHSS+CH_fSS)-(wSS*NSS*y/(alpha_N*ySS))*(CHSS+CH_fSS)+(phSS*CHSS-(wSS*NSS/(alpha_N*ySS))*CHSS)*CH + (phSS*CH_fSS-(wSS*NSS/(alpha_N*ySS))*CH_fSS)*CH_f+pfSS*CFSS*pf-pf_fSS*CFSS*pf_f+(pfSS-pf_fSS)*CFSS*CF;
//AR1-processes
t*tSS=tau_h_ss*wSS*NSS*(tau_h+w+N)+tau_PSS*PSS*(tau_P+P);
b_h=(t-phi_g*G)/phi_b;
tf*tfSS=tau_c_ss*CSS*(tau_c+C);
//bf=(tf-phi_g*Gf)/phi_b;
G = rho_g*G(-1)+(1-rho_g)*mu_g*b_h+xi_g;
Gf = rho_gf*Gf(-1)+(1-rho_gf)*mu_g*bf+xi_gf;
y_f = rho_y*y_f(-1)+xi_y;
pf_f = rho_pf_f*pf_f(-1)+xi_pf_f;
C_f = rho_C_f*C_f(-1)+xi_C_f;
//I_f = rho_I_f*I_f(-1)+xi_I_f;
z_y = rho_y*z_y(-1)+xi_y;
tau_c= rho_tau_c*tau_c(-1)+(1-rho_tau_c)*mu_tau_c*(bf-y_f(-1))+xi_tau_c;
tau_h= rho_tau_h*tau_h(-1)++(1-rho_tau_h)*mu_tau_h*(b_h-y(-1))+xi_tau_h;
tau_P= rho_tau_P*tau_P(-1)++(1-rho_tau_P)*mu_tau_P*(b_h-y(-1))+xi_tau_P;
//Observable
yobs=y;
piobs=pi;
y_fobs=y_f;
cobs=C;
wobs=w;
pif_fobs=pif_f;
robs=rf;
end;
// Declaring observables
varobs  cobs piobs  wobs   yobs y_fobs pif_fobs robs;
// Compute steady state
steady; //(solve_algo = 0);
// Compute eigenvalues and check Blanchard-Kahn conditions
check;
estimated_params;
phi,inv_gamma_pdf,0.002,0.5;
vphi,inv_gamma_pdf,1.577,0.5;
eta,inv_gamma_pdf,1.1,0.5;
//ksi,inv_gamma_pdf,1,0.5;
//mu_g,inv_gamma_pdf,0.2,0.2;
//mu_tau_c,inv_gamma_pdf,0.1,0.2;
//mu_tau_h,inv_gamma_pdf,0.1,0.2;
//mu_tau_P,inv_gamma_pdf,0.1,0.2;
omega_pi,inv_gamma_pdf,1.5,0.2;
omega_y,inv_gamma_pdf,0.3,0.2;
//omega_r,inv_gamma_pdf,0.8,0.2;
//rho_y, beta_pdf, 0.4, 0.2;
//rho_g, beta_pdf, 0.5, 0.2;
//rho_gf, beta_pdf, 0.5, 0.2;
rho_rf, beta_pdf, 0.5, 0.2;
rho_C_f, beta_pdf, 0.5, 0.2;
//rho_tau_c,beta_pdf, 0.5, 0.2;
//rho_tau_h,beta_pdf, 0.5, 0.2;
rho_tau_P,beta_pdf, 0.5, 0.2;
stderr xi_y,INV_GAMMA_PDF,0.02,inf;
stderr xi_b,INV_GAMMA_PDF,0.02,inf;
stderr xi_g,INV_GAMMA_PDF,0.012,inf;
stderr xi_gf,INV_GAMMA_PDF,0.012,inf;
stderr xi_rf,INV_GAMMA_PDF,.0025,inf;
stderr xi_pf_f,INV_GAMMA_PDF,.0025,inf;
stderr xi_tau_c,INV_GAMMA_PDF,0.05,inf;
stderr xi_tau_h,INV_GAMMA_PDF,0.05,inf;
stderr xi_tau_P,INV_GAMMA_PDF,0.05,inf;
stderr xi_C_f,INV_GAMMA_PDF,0.02,inf;
//stderr xi_I_f,INV_GAMMA_PDF,0.02,inf;
end;
estimation(datafile=data_reg,mode_compute=4,kalman_algo=1,lik_init=2,prefilter=1,mh_replic=500,mh_nblocks=1,
mh_jscale=0.5,mode_check);

stoch_simul(irf=20) C I K pi t tf;